# This script is a fix of two scripts,
# the first by sicman_adrian (http://forums.mattie.info/cs/forums/viewtopic.php?p=250741&highlight=fall#250710)
# the second by jeff91 (http://forums.mattie.info/cs/forums/viewtopic.php?p=250753#250808)
# released on request by PatPeter

# requires ES 2.0+, ES_tools or source python extensions

import es

class est: #yup, it ignores passed arguments o.~
    def registerPreHook(self, event, func):
        es.server.cmd('est_RegEventBlock player_falldamage "es_xdoblock falldamage/pre_falldamage"')
    def unregisterPreHook(self, event, func):
        es.server.cmd('est_UnRegEventBlock player_falldamage "es_xdoblock falldamage/pre_falldamage"')
        
using = 'spe'
try:
   import spe
except ImportError:
   spe = est()
   using = 'est'

info = es.AddonInfo()
info.name     = "Anti Fall Damage"
info.version  = "2.0"
info.url      = "http://forums.mattie.info/cs/forums/viewtopic.php?t=30462"
info.basename = "falldamage"
info.author   = "DanielB"


def load():
    spe.registerPreHook('player_falldamage', pre_falldamage)
    es.msg('#multi', '#green[AntiFallDamage]#lightgreen Loaded (using %s)'%using)

def unload():
    spe.unregisterPreHook('player_falldamage', pre_falldamage)
    es.msg('#multi', '#green[AntiFallDamage]#lightgreen Unloaded')

def returnEV(var):
    val = es.ServerVar('afd_tmp')
    val.set(0)
    es.server.cmd('est_GetEventInfo afd_tmp '+var)
    return val

def getVars():
    ret = {}
    ret['userid'] = str(returnEV('userid'))
    ret['damage'] = int(returnEV('damage'))
    return ret

def pre_falldamage(ev=None):
    if ev is None: ev = getVars()
    es.dbgmsg(0, 'Player_falldamage')
    userid = ev['userid']
    es.dbgmsg(0, 'userid = %s'%userid)
    dmg = ev['damage']
    es.dbgmsg(0, 'dmg = %s'%dmg)
    health = int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth'))
    es.setplayerprop(userid, 'CBasePlayer.m_iHealth', health + dmg)
